## Hard-coded Cryptography

### Summary

Usage of hard-coded cryptography reduces the crypto agility of an application, which can hinder attempts to move away from vulnerable cryptography.

### Details

Crypto agility is the ability of an application to migrate from one cryptographic algorithm to another. This ability is valuable both in situations where new, stronger cryptographic algorithms become available, and new attacks against existing cryptographic algorithms become known, making those algorithms no longer safe to use.

Crypto agility includes being able to switch parameters of an existing algorithm, such as switching between AES-128 and AES-256.

In order to facilitate this ability, hard-coding crypto algorithms and parameters is not recommended.

### References

* [https://learn.microsoft.com/en-us/archive/msdn-magazine/2009/brownfield/cryptographic-agility](https://learn.microsoft.com/en-us/archive/msdn-magazine/2009/brownfield/cryptographic-agility)
